diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.h b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.h
index bc885ca2..75e42d60 100644
--- a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.h
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.h
@@ -55,7 +55,8 @@ namespace SHADE
       /* Getter Functions                                                              */
       /*-------------------------------------------------------------------------------*/
       bool WasMaterialChanged() const noexcept { return materialChanged; }
-      Handle<SHMaterial> GetPrevMaterial() const noexcept { return oldMaterial; }
+      Handle<SHMaterialInstance> GetPrevMaterial() const noexcept { return oldMaterial; }
+      uint8_t GetLightLayer (void) const noexcept;
 
       /*-------------------------------------------------------------------------------*/
       /* Batcher Dispatcher Functions                                                  */
@@ -74,7 +75,8 @@ namespace SHADE
       Handle<SHMaterialInstance> sharedMaterial;
       Handle<SHMaterialInstance> material;
       bool materialChanged = true;
-      Handle<SHMaterial> oldMaterial; 
+      Handle<SHMaterialInstance> oldMaterial; 
+      uint8_t lightLayer;
 	};
 }
 
diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderer.cpp b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderer.cpp
index 2532f308..962130be 100644
--- a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderer.cpp
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderer.cpp
@@ -21,6 +21,7 @@ of DigiPen Institute of Technology is prohibited.
 #include "Graphics/MiddleEnd/Interface/SHGraphicsConstants.h"
 #include "Graphics/Descriptors/SHVkDescriptorSetGroup.h"
 #include "Graphics/Buffers/SHVkBuffer.h"
+#include "Camera/SHCameraDirector.h"
 
 namespace SHADE
 {
@@ -65,6 +66,11 @@ namespace SHADE
     camera = _camera;
   }
 
+  void SHRenderer::SetCameraDirector(Handle<SHCameraDirector> director) noexcept
+  {
+    cameraDirector = director;
+  }
+
   /*-----------------------------------------------------------------------------------*/
   /* Drawing Functions                                                                 */
   /*-----------------------------------------------------------------------------------*/
@@ -75,17 +81,24 @@ namespace SHADE
 
   void SHRenderer::UpdateDataAndBind(Handle<SHVkCommandBuffer> cmdBuffer, uint32_t frameIndex) noexcept
   {
-    if (camera)
+    if (camera && cameraDirector)
     {
-      //cpuCameraData.viewProjectionMatrix = camera->GetViewProjectionMatrix();
-      cameraBuffer->WriteToMemory(&cpuCameraData, sizeof(SHShaderCameraData), 0, cameraDataAlignedSize * frameIndex);
-
-        std::array<uint32_t, 1> dynamicOffsets{ frameIndex * cameraDataAlignedSize };
-
-      cmdBuffer->BindDescriptorSet(cameraDescriptorSet, vk::PipelineBindPoint::eGraphics, SHGraphicsConstants::DescriptorSetIndex::HIGH_FREQUENCY_GLOBALS, std::span{ dynamicOffsets.data(), 1 });
+      UpdateDataAndBind(cmdBuffer, frameIndex, SHMatrix::Transpose(cameraDirector->GetVPMatrix()));
     }
   }
 
+  void SHRenderer::UpdateDataAndBind(Handle<SHVkCommandBuffer> cmdBuffer, uint32_t frameIndex, SHMatrix exteriorMatrix) noexcept
+  {
+    SetViewProjectionMatrix(exteriorMatrix);
+
+    //cpuCameraData.viewProjectionMatrix = camera->GetViewProjectionMatrix();
+    cameraBuffer->WriteToMemory(&cpuCameraData, sizeof(SHShaderCameraData), 0, cameraDataAlignedSize * frameIndex);
+
+    std::array<uint32_t, 1> dynamicOffsets{ frameIndex * cameraDataAlignedSize };
+
+    cmdBuffer->BindDescriptorSet(cameraDescriptorSet, SH_PIPELINE_TYPE::GRAPHICS, SHGraphicsConstants::DescriptorSetIndex::HIGH_FREQUENCY_GLOBALS, std::span{ dynamicOffsets.data(), 1 });
+  }
+
   void SHRenderer::UpdateCameraDataToBuffer(void) noexcept
   {
   }
diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderer.h b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderer.h
index dbd1e415..87cf8ee9 100644
--- a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderer.h
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderer.h
@@ -40,6 +40,7 @@ namespace SHADE
     class SHGraphicsGlobalData;
     class SHVkDescriptorPool;
     class SHVkBuffer;
+    class SHCameraDirector;
 
     struct SHShaderCameraData
     {
@@ -71,12 +72,14 @@ namespace SHADE
         /* Camera Registration                                                         */
         /*-----------------------------------------------------------------------------*/
         void SetCamera(Handle<SHCamera> _camera);
+        void SetCameraDirector (Handle<SHCameraDirector> director) noexcept;
 
         /*-----------------------------------------------------------------------------*/
         /* Drawing Functions                                                           */
         /*-----------------------------------------------------------------------------*/
         void Draw(uint32_t frameIndex, Handle<SHVkDescriptorPool> descPool) noexcept;
-        void UpdateDataAndBind (Handle<SHVkCommandBuffer> cmdBuffer, uint32_t frameIndex) noexcept;
+        void UpdateDataAndBind(Handle<SHVkCommandBuffer> cmdBuffer, uint32_t frameIndex) noexcept;
+        void UpdateDataAndBind(Handle<SHVkCommandBuffer> cmdBuffer, uint32_t frameIndex, SHMatrix exteriorMatrix) noexcept;
         void UpdateCameraDataToBuffer (void) noexcept;
         void SetViewProjectionMatrix (SHMatrix const& vpMatrix) noexcept;
 
@@ -99,6 +102,8 @@ namespace SHADE
         Handle<SHVkDescriptorSetGroup>  cameraDescriptorSet;
         Handle<SHVkBuffer>              cameraBuffer;
 
+        Handle<SHCameraDirector>        cameraDirector;
+
         // we really only need 1 copy even though we need %swapchainImages copies for
         // GPU.
         SHShaderCameraData              cpuCameraData; 
diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightComponent.cpp b/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightComponent.cpp
new file mode 100644
index 00000000..fd122334
--- /dev/null
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightComponent.cpp
@@ -0,0 +1,123 @@
+#include "SHpch.h"
+#include "SHLightComponent.h"
+
+namespace SHADE
+{
+
+
+  void SHLightComponent::OnCreate(void)
+  {
+    lightData.Reset();
+    SetType(SH_LIGHT_TYPE::DIRECTIONAL);
+    indexInBuffer = std::numeric_limits<uint32_t>::max();
+    active = true;
+    Unbind();
+  }
+
+
+  void SHLightComponent::OnDestroy(void)
+  {
+
+  }
+
+  void SHLightComponent::SetPosition(SHVec3 position) noexcept
+  {
+    lightData.position = position;
+    MakeDirty();
+  }
+
+
+  void SHLightComponent::SetType(SH_LIGHT_TYPE type) noexcept
+  {
+    lightData.type = type;
+    MakeDirty();
+  }
+
+
+  void SHLightComponent::SetDirection(SHVec3 direction) noexcept
+  {
+    lightData.direction = direction;
+    MakeDirty();
+  }
+
+
+  void SHLightComponent::SetDiffuseColor(SHVec4 diffuseColor) noexcept
+  {
+    lightData.diffuseColor = diffuseColor;
+    MakeDirty();
+  }
+
+  void SHLightComponent::ModifyLayer(uint8_t layerIndex, bool value) noexcept
+  {
+    if (value)
+      lightData.cullingMask |= (1u << layerIndex);
+    else
+      lightData.cullingMask &= ~(1u << layerIndex);
+
+    MakeDirty();
+  }
+
+
+  void SHLightComponent::SetAllLayers(void) noexcept
+  {
+    lightData.cullingMask = std::numeric_limits<uint32_t>::max();
+    MakeDirty();
+  }
+
+
+  void SHLightComponent::ClearAllLayers(void) noexcept
+  {
+    lightData.cullingMask = 0;
+    MakeDirty();
+  }
+
+  void SHLightComponent::MakeDirty(void) noexcept
+  {
+    dirty = true;
+  }
+
+  void SHLightComponent::ClearDirtyFlag(void) noexcept
+  {
+    dirty = false;
+  }
+
+  void SHLightComponent::Unbind(void) noexcept
+  {
+    bound = false;
+    MakeDirty();
+  }
+
+  void SHLightComponent::SetBound(uint32_t inIndexInBuffer) noexcept
+{
+    bound = true;
+    indexInBuffer = inIndexInBuffer;
+  }
+
+  void SHLightComponent::SetActive(bool flag) noexcept
+  {
+    MakeDirty();
+    active = flag;
+
+  }
+
+  SHLightData const& SHLightComponent::GetLightData(void) const noexcept
+  {
+    return lightData;
+  }
+
+  bool SHLightComponent::IsDirty(void) const noexcept
+  {
+    return dirty;
+  }
+
+  bool SHLightComponent::GetBound(void) const noexcept
+  {
+    return bound;
+  }
+
+  uint32_t SHLightComponent::GetIndexInBuffer(void) const noexcept
+  {
+    return indexInBuffer;
+  }
+
+}
diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightComponent.h b/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightComponent.h
new file mode 100644
index 00000000..20ae3892
--- /dev/null
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightComponent.h
@@ -0,0 +1,60 @@
+#pragma once
+
+#include "ECS_Base/Components/SHComponent.h"
+#include "SHLightData.h"
+
+namespace SHADE
+{
+
+  class SH_API SHLightComponent final : public SHComponent
+  {
+  private:
+    //! General data for the light. This will purely be CPU bound. Whatever gets sent to the
+    //! GPU depends on the type of the light. 
+    SHLightData lightData;
+
+    //! Since the lighting system is gonna be self contained and light weight, we store this
+    //! so that we only write this to the CPU buffer when this light component change, we don't 
+    //! rewrite everything. However we still write to the GPU buffer when everything changes.
+    uint32_t indexInBuffer;
+
+    //! If the light component changed some value we mark this true.
+    bool dirty;
+
+    //! If the light's data is already in the buffers, this will be set to true.
+    bool bound;
+
+    //! If the light is active, this is true.
+    bool active;
+  	
+  public:
+    /*-----------------------------------------------------------------------*/
+    /* LIFECYCLE FUNCTIONS                                                   */
+    /*-----------------------------------------------------------------------*/
+    void OnCreate  (void) override final;
+    void OnDestroy (void) override final;
+
+    /*-----------------------------------------------------------------------*/
+    /* SETTERS AND GETTERS                                                   */
+    /*-----------------------------------------------------------------------*/
+    void SetPosition     (SHVec3 position) noexcept;
+    void SetType         (SH_LIGHT_TYPE type) noexcept;
+    void SetDirection    (SHVec3 direction) noexcept;
+    void SetDiffuseColor (SHVec4 diffuseColor) noexcept;
+    void ModifyLayer     (uint8_t layerIndex, bool value) noexcept;
+    void SetAllLayers    (void) noexcept;
+    void ClearAllLayers  (void) noexcept;
+    void MakeDirty       (void) noexcept;
+    void ClearDirtyFlag  (void) noexcept;
+    void Unbind          (void) noexcept;
+    void SetBound        (uint32_t inIndexInBuffer) noexcept;
+    void SetActive       (bool flag) noexcept;
+    
+
+    SHLightData const& GetLightData     (void) const noexcept;
+    bool               IsDirty          (void) const noexcept;
+    bool               GetBound         (void) const noexcept;
+    uint32_t           GetIndexInBuffer (void) const noexcept;
+
+  };
+}
diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightData.cpp b/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightData.cpp
new file mode 100644
index 00000000..ba910408
--- /dev/null
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightData.cpp
@@ -0,0 +1,21 @@
+#include "SHpch.h"
+#include "SHLightData.h"
+
+namespace SHADE
+{
+  void SHLightData::Reset(void) noexcept
+  {
+    // no culling is done.
+    cullingMask = std::numeric_limits<uint32_t>::max();
+
+    // reset position to 0
+    position = SHVec3::Zero;
+
+    // direction just point in positive z axis
+    direction = SHVec3::Forward; 
+
+    // Diffuse color set to 1
+    diffuseColor = SHVec4::One;
+  }
+
+}
\ No newline at end of file
diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightData.h b/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightData.h
new file mode 100644
index 00000000..607978a4
--- /dev/null
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightData.h
@@ -0,0 +1,55 @@
+#pragma once
+
+#include "Math/Vector/SHVec3.h"
+#include "Math/Vector/SHVec4.h"
+
+namespace SHADE
+{
+  enum class SH_LIGHT_TYPE : uint32_t
+  {
+    DIRECTIONAL = 0,
+    POINT,
+    SPOT,
+    NUM_TYPES
+  };
+
+  /***************************************************************************/
+  /*!
+
+    \class
+      Every light will essentially be using this struct. However, when passing
+      light data over to the GPU, the light data will be split according to 
+      type for more optimal cache access.
+
+  */
+  /***************************************************************************/
+  struct SHLightData
+  {
+    //! position of the light
+    SHVec3 position;
+
+    //! Type of the light
+    SH_LIGHT_TYPE type;
+
+    //! direction of the light
+    SHVec3 direction;
+
+    //! Each bit in this 32 bit field will represent a layer. If the bit is set,
+    //! when a fragment is being evaluated, the shader will use the fragment's
+    //! layer value to AND with the light's. If result is 1, do lighting calculations.
+    uint32_t cullingMask;  
+
+    //! Diffuse color emitted by the light
+    SHVec4 diffuseColor;
+
+    void Reset (void) noexcept;
+    //! TODO: 
+    //! - Add cut off. (inner and outer).
+    //! - Add constant, linear and quadratic for attenuation
+    //! - Specular color if needed. see below.
+
+    //! Specular color
+    //SHVec4 specularColor;
+  };
+
+}
diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightingSubSystem.cpp b/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightingSubSystem.cpp
new file mode 100644
index 00000000..8d9efe54
--- /dev/null
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Lights/SHLightingSubSystem.cpp
@@ -0,0 +1,431 @@
+#include "SHpch.h"
+#include "SHLightingSubSystem.h"
+#include "Graphics/MiddleEnd/GlobalData/SHGraphicsGlobalData.h"
+#include "Tools/SHUtilities.h"
+#include "Graphics/Devices/SHVkLogicalDevice.h"
+#include "Graphics/Buffers/SHVkBuffer.h"
+#include "Graphics/Descriptors/SHVkDescriptorSetGroup.h"
+#include "SHLightComponent.h"
+#include "ECS_Base/Managers/SHComponentManager.h"
+#include "SHLightComponent.h"
+
+namespace SHADE
+{
+  /***************************************************************************/
+  /*! 
+   
+    \brief
+      This function takes an address in the CPU container and writes light
+      component data to it. What gets written depends on the light type.
+    
+    \param address
+      The address to write to.
+
+    \param lightComp
+      The light component with the data to write from.
+
+    \param lightType
+      The type of the light
+   
+    \return 
+  
+  */ 
+  /***************************************************************************/
+  void SHLightingSubSystem::PerTypeData::WriteLightToAddress(void* address, SHLightComponent* lightComp) noexcept
+  {
+    auto const& lightData = lightComp->GetLightData();
+    switch (lightData.type)
+    {
+    case SH_LIGHT_TYPE::DIRECTIONAL:
+    {
+      SHDirectionalLightData* lightPtr = reinterpret_cast<SHDirectionalLightData*>(address);
+
+      lightPtr->cullingMask = lightData.cullingMask;
+      lightPtr->direction = lightData.direction;
+      lightPtr->diffuseColor = lightData.diffuseColor;
+      break;
+    }
+    case SH_LIGHT_TYPE::POINT:
+      break;
+    case SH_LIGHT_TYPE::SPOT:
+      break;
+    case SH_LIGHT_TYPE::NUM_TYPES:
+      break;
+    default:
+      break;
+
+    }
+  }
+
+  /***************************************************************************/
+  /*!
+
+    \brief
+      Initializes type, intermediate data and buffer. dirty will be true.
+
+    \param lightType
+      type of the light. 
+
+  */
+  /***************************************************************************/
+  void SHLightingSubSystem::PerTypeData::InitializeData(Handle<SHVkLogicalDevice> logicalDevice, SH_LIGHT_TYPE type) noexcept
+  {
+    // initialize the type
+    lightType = type;
+
+    // boilerplate
+    intermediateData = nullptr;
+
+    // initialize alignment
+    lightDataAlignmentSize = logicalDevice->PadSSBOSize(GetLightTypeSize(type));
+
+    // So create some data!
+    Expand(logicalDevice);
+  }
+
+  /***************************************************************************/
+  /*!
+  
+    \brief
+      Expands both the CPU container and the GPU buffer when the number of 
+      lights have exceeded the capacity. 
+    
+  */
+  /***************************************************************************/
+  void SHLightingSubSystem::PerTypeData::Expand(Handle<SHVkLogicalDevice> logicalDevice) noexcept
+  {
+    if (lightDataAlignmentSize == 0)
+    {
+      SHLOG_ERROR ("One of the types of lights have not been accounted for. Make sure lightDataAlignmentSize is not nullptr.");
+      return;
+    }
+
+    // we want to wait for the command buffers to finish using the buffers first
+    logicalDevice->WaitIdle();
+
+    // First time we are initializing lights
+    if (intermediateData == nullptr)
+    {
+      // max lights should start of at STARTING_NUM_LIGHTS lights
+      maxLights = STARTING_NUM_LIGHTS;
+      numLights = 0;
+
+      // Initialize the data for lights
+      intermediateData = std::make_unique<uint8_t[]>(lightDataAlignmentSize * maxLights);
+
+      // We want to initialize 3 times the amount of data required.
+      dataBuffer = logicalDevice->CreateBuffer(maxLights * lightDataAlignmentSize * SHGraphicsConstants::NUM_FRAME_BUFFERS, nullptr, maxLights * lightDataAlignmentSize * SHGraphicsConstants::NUM_FRAME_BUFFERS, vk::BufferUsageFlagBits::eStorageBuffer, VMA_MEMORY_USAGE_AUTO, VMA_ALLOCATION_CREATE_MAPPED_BIT | VMA_ALLOCATION_CREATE_HOST_ACCESS_SEQUENTIAL_WRITE_BIT);
+    }
+    else
+    {
+      // save old number of lights
+      uint32_t const OLD_MAX_LIGHTS = maxLights;
+
+      // before we increase the number of lights, create space to store old data.
+      std::unique_ptr<uint8_t[]> oldData = std::make_unique<uint8_t[]>(lightDataAlignmentSize * OLD_MAX_LIGHTS);
+
+      // copy data over.
+      std::memcpy (oldData.get(), intermediateData.get(), lightDataAlignmentSize * OLD_MAX_LIGHTS);
+
+      // now we start to expand....
+
+      // double space for lights
+      maxLights *= 2;
+
+      // destroy old data and initialize container for double the amount of data.
+      intermediateData = std::make_unique<uint8_t[]>(lightDataAlignmentSize * maxLights);
+
+      // copy old data to new container
+      std::memcpy(intermediateData.get(), oldData.get(), lightDataAlignmentSize * OLD_MAX_LIGHTS);
+
+      // Resize the GPU buffer. TODO: Replace with Resize no copy here
+      dataBuffer->ResizeReplace(maxLights * lightDataAlignmentSize * SHGraphicsConstants::NUM_FRAME_BUFFERS, oldData.get(), lightDataAlignmentSize * OLD_MAX_LIGHTS);
+    }
+
+    
+  }
+
+  /***************************************************************************/
+  /*!
+  
+    \brief
+      Gets the size required to store data for a light type.
+    
+    \param type
+      Type of a light.
+   
+    \return 
+      Size required to store a light based on type.  
+
+  */
+  /***************************************************************************/
+  uint32_t SHLightingSubSystem::PerTypeData::GetLightTypeSize(SH_LIGHT_TYPE type) noexcept
+  {
+    switch (type)
+    {
+    case SH_LIGHT_TYPE::DIRECTIONAL:
+      // TOOD: Change after creating point light struct
+      return sizeof(SHDirectionalLightData);
+    case SH_LIGHT_TYPE::POINT:
+      return 4;
+    case SH_LIGHT_TYPE::SPOT:
+      // TOOD: Change after creating spot light struct
+      return 4; 
+    case SH_LIGHT_TYPE::NUM_TYPES:
+    default:
+      return 4;
+
+    }
+  }
+
+
+  Handle<SHVkBuffer> SHLightingSubSystem::PerTypeData::GetDataBuffer(void) const noexcept
+  {
+    return dataBuffer;
+  }
+
+
+  uint32_t SHLightingSubSystem::PerTypeData::GetAlignmentSize(void) const noexcept
+  {
+    return lightDataAlignmentSize;
+  }
+
+  uint32_t SHLightingSubSystem::PerTypeData::GetNumLights(void) const noexcept
+  {
+    return numLights;
+  }
+
+  uint32_t SHLightingSubSystem::PerTypeData::GetMaxLights(void) const noexcept
+  {
+    return maxLights;
+  }
+
+
+  /***************************************************************************/
+  /*!
+
+    \brief
+      This function takes in a light comp in the event that its data has not
+      been placed in the buffer yet. It also checks if the size of the buffer
+      is big enough to hold the new light. If the buffer is too small, expand
+      it.
+
+    \param lightComp
+      The light component to add.
+
+  */
+  /***************************************************************************/
+  void SHLightingSubSystem::PerTypeData::AddLight(Handle<SHVkLogicalDevice> logicalDevice, SHLightComponent* unboundLight, bool expanded) noexcept
+  {
+    if (unboundLight)
+    {
+      // capacity is full
+      if (numLights == maxLights)
+      {
+        // expand first
+        Expand(logicalDevice);
+
+        expanded = true;
+      }
+
+      // Now that the container is big enough, bind the new light
+
+      // Get address of write location
+      void* writeLocation = reinterpret_cast<uint8_t*>(intermediateData.get()) + (lightDataAlignmentSize * numLights);
+
+      // Write the light data to address
+      WriteLightToAddress(writeLocation, unboundLight);
+
+      // Set the light component to be bound to that location
+      unboundLight->SetBound(numLights);
+
+      // Increase light count
+      ++numLights;
+    }
+  }
+
+  /***************************************************************************/
+  /*! 
+   
+    \brief
+      Modify the data at a specific light address.
+    
+    \param lightComp
+      The light component to write.
+   
+  */ 
+  /***************************************************************************/
+  void SHLightingSubSystem::PerTypeData::ModifyLight(SHLightComponent* lightComp) noexcept
+  {
+    void* writeLocation = reinterpret_cast<uint8_t*>(intermediateData.get()) + (lightDataAlignmentSize * lightComp->GetIndexInBuffer());
+    WriteLightToAddress(writeLocation, lightComp);
+  }
+
+  void SHLightingSubSystem::PerTypeData::WriteToGPU(uint32_t frameIndex) noexcept
+  {
+    if (intermediateData)
+    {
+      // we want to write to the offset of the current frame
+      dataBuffer->WriteToMemory(intermediateData.get(), lightDataAlignmentSize * numLights, 0, lightDataAlignmentSize * maxLights * frameIndex);
+    }
+  }
+
+  /***************************************************************************/
+  /*! 
+   
+    \brief
+      Update descriptor sets. We want to call this every time we expand buffers.
+    
+    \param binding
+      The binding in the set we want to update.
+   
+  */ 
+  /***************************************************************************/
+  void SHLightingSubSystem::UpdateDescSet(uint32_t binding) noexcept
+  {
+    auto buffer = perTypeData[binding].GetDataBuffer();
+
+    // We bind the buffer with the correct desc set binding
+    lightingDataDescSet->ModifyWriteDescBuffer(SHGraphicsConstants::DescriptorSetIndex::DYNAMIC_GLOBALS,
+      binding,
+      { &buffer, 1 },
+      0,
+      perTypeData[binding].GetAlignmentSize() * perTypeData[binding].GetMaxLights());
+
+    lightingDataDescSet->UpdateDescriptorSetBuffer(SHGraphicsConstants::DescriptorSetIndex::DYNAMIC_GLOBALS, binding);
+  }
+
+  /***************************************************************************/
+  /*!
+
+    \brief
+      Computes dynamic offsets.
+
+  */
+  /***************************************************************************/
+  void SHLightingSubSystem::ComputeDynamicOffsets(void) noexcept
+  {
+    for (uint32_t i = 0; i < SHGraphicsConstants::NUM_FRAME_BUFFERS; ++i)
+    {
+      for (uint32_t j = 0; j < dynamicOffsets.size(); ++j)
+      {
+        auto const& typeData = perTypeData[j];
+        {
+          dynamicOffsets[i][j] = j * typeData.GetAlignmentSize() * typeData.GetMaxLights();
+        }
+      }
+    }
+  }
+
+  /***************************************************************************/
+  /*!
+  
+    \brief
+      Initializes per light type data. This includes buffers and descriptor
+      sets.
+    
+  
+  */
+  /***************************************************************************/
+  void SHLightingSubSystem::Init(Handle<SHVkLogicalDevice> device, Handle<SHVkDescriptorPool> descPool) noexcept
+  {
+    SHComponentManager::CreateComponentSparseSet<SHLightComponent>();
+
+    logicalDevice = device;
+    uint32_t constexpr NUM_LIGHT_TYPES = SHUtilities::ToUnderlying(SH_LIGHT_TYPE::NUM_TYPES);
+
+    std::vector<uint32_t> variableSizes{ NUM_LIGHT_TYPES };
+    std::fill (variableSizes.begin(), variableSizes.end(), 1);
+
+    // Create the descriptor set
+    lightingDataDescSet = descPool->Allocate({SHGraphicsGlobalData::GetDescSetLayouts()[SHGraphicsConstants::DescriptorSetIndex::DYNAMIC_GLOBALS]}, variableSizes);
+
+
+    for (uint32_t i = 0; i < NUM_LIGHT_TYPES; ++i)
+    {
+      // initialize all the data first. We add more lights here as we add more types.
+      perTypeData[i].InitializeData(logicalDevice, static_cast<SH_LIGHT_TYPE>(i));
+      UpdateDescSet(i);
+    }
+
+    for (uint32_t i = 0; i < SHGraphicsConstants::NUM_FRAME_BUFFERS; ++i)
+    {
+    	dynamicOffsets[i].resize(NUM_LIGHT_TYPES);
+    }
+  }
+
+  /***************************************************************************/
+  /*!
+  
+    \brief
+      Loops through every single light component and checks for dirty light
+      data. If light data is dirty, rewrite to the CPU container. We also want
+      to bind the descriptor set for the light data.
+    
+  */
+  /***************************************************************************/
+  void SHLightingSubSystem::Run(Handle<SHVkCommandBuffer> cmdBuffer, uint32_t frameIndex) noexcept
+  {
+    auto& lightComps = SHComponentManager::GetDense<SHLightComponent>();
+    bool expanded = false;
+    for (auto& light : lightComps)
+    {
+      auto enumValue = SHUtilities::ToUnderlying(light.GetLightData().type);
+
+      // First we want to make sure the light is already bound to the system. if it
+      // isn't, we write it to the correct buffer.
+      if (!light.GetBound())
+      {
+        perTypeData[enumValue].AddLight(logicalDevice, &light, expanded);
+      }
+
+      // if there was modification to the light data
+      if (light.IsDirty())
+      {
+        // Write the data to the CPU 
+        perTypeData[enumValue].ModifyLight(&light);
+
+        // Light is now updated in the container
+        light.ClearDirtyFlag();
+      }
+    }
+
+    // Write data to GPU
+    for (auto& data : perTypeData)
+    {
+    	data.WriteToGPU(frameIndex);
+    }
+
+    // If any of the buffers got expanded, the descriptor set is invalid because the expanded buffer
+    // is a new buffer. If some expansion was detected, update descriptor sets.
+    if (expanded)
+    {
+      uint32_t constexpr NUM_LIGHT_TYPES = SHUtilities::ToUnderlying(SH_LIGHT_TYPE::NUM_TYPES);
+      for (uint32_t i = 0; i < NUM_LIGHT_TYPES; ++i)
+      {
+      	UpdateDescSet(i);
+      }
+    }
+    
+    // compute dynamic offsets. We don't actually have to compute every frame but its pretty lightweight,
+    // so we do it anyway. #NoteToSelf: if at any point it affects performance, do a check before computing.
+    ComputeDynamicOffsets();
+
+    // Bind descriptor set (We bind at an offset because the buffer holds NUM_FRAME_BUFFERS sets of data).
+    cmdBuffer->BindDescriptorSet(lightingDataDescSet, SH_PIPELINE_TYPE::GRAPHICS, SHGraphicsConstants::DescriptorSetIndex::DYNAMIC_GLOBALS, {dynamicOffsets[frameIndex]});
+
+  }
+
+  /***************************************************************************/
+  /*!
+  
+    \brief
+      Does nothing for now.
+    
+  */
+  /***************************************************************************/
+  void SHLightingSubSystem::Exit(void) noexcept
+  {
+
+  }
+}
